HDU 1856 More is better

More is better

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 327680/102400 K (Java/Others)
Total Submission(s): 31520    Accepted Submission(s): 11175


Problem Description
Mr Wang wants some boys to help him with a project. Because the project is rather complex,  the more boys come, the better it will be. Of course there are certain requirements.

Mr Wang selected a room big enough to hold the boys. The boy who are not been chosen has to leave the room immediately. There are 10000000 boys in the room numbered from 1 to 10000000 at the very beginning. After Mr Wang's selection any two of them who are still in this room should be friends (direct or indirect), or there is only one boy left. Given all the direct friend-pairs, you should decide the best way.
 

Input
The first line of the input contains an integer n (0 ≤ n ≤ 100 000) - the number of direct friend-pairs. The following n lines each contains a pair of numbers A and B separated by a single space that suggests A and B are direct friends. (A ≠ B, 1 ≤ A, B ≤ 10000000)
 

Output
The output in one line contains exactly one integer equals to the maximum number of boys Mr Wang may keep. 
 

Sample Input
 
   
41 23 45 61 641 23 45 67 8
 

Sample Output
 
   
42


题解:
虽然人数很多,但是关系最多只有100000,因此有关系的
最多只有200000个人,因此数组只需开到二十万,用map映射。
然后并查集建立完后,在一次遍历每个元素的父节点,输出
出现最多的父节点即可。

代码:

#include
using namespace std;
mapmp;
int par[200007],t[200007];
void init()
{
    for(int i=0;i<200007;i++)
        par[i]=i;
}
int find(int x)
{
    if(par[x]==x)return x;
    return par[x]=find(par[x]);
}
void unite(int x,int y)
{
    x=find(x);y=find(y);
    if(x!=y)
        par[x]=y;
}
int main()
{
    int n;
    while(~scanf("%d",&n))
    {
        if(n==0)
        {
            printf("1\n");
            continue;
        }
        init();
        memset(t,0,sizeof(t));
        int i,j,k=0;
        for(i=1;i<=n;i++)
        {
            int x,y;scanf("%d%d",&x,&y);
            if(!mp[x])mp[x]=++k;
            if(!mp[y])mp[y]=++k;
            unite(mp[x],mp[y]);
        }
        int ma=0;
        for(i=1;i<=k;i++)
        {
            int x=find(i);
            t[x]++;
            ma=max(ma,t[x]);
        }
        printf("%d\n",ma);
        mp.clear();
    }
    return 0;
}

你可能感兴趣的:(并查集)